# MULTI REMOTE EXECUTION WITH SSH

A shellscript written in Bash to execute a single command on one or many target hosts via ssh.
A target host can define a jumphost if it is not accessible directly.

The script is designed to run in interactive mode but supports command line parameters for scripting too.

## Installation

Go to your directory where you place scripts and clone it

With read access - via https:

```txt
cd ~/scripts
git clone https://git-repo.iml.unibe.ch/admins/multi-remote-execution.git``
```

As developer - to submit changes into git via ssh

```txt
cd ~/scripts
git clone git@git-repo.iml.unibe.ch:admins/multi-remote-execution.git
```

## First start

Just start `multi_ssh.sh` - it will initialize a user config file with the defaults.
Without a parameter you reach the interactive mode.

To see the parameters start `multi_ssh.sh -h`

```txt
_______________________________________________________________________________

 MULTI REMOTE EXECUTION WITH SSH                                         ______
________________________________________________________________________/ v0.14

SYNTAX:
    multi_ssh.sh [OPTIONS] [SERVERLIST]

OPTIONS:
    -c|--command [COMMAMD]
                 set a command for remote execution. A 2nd value
                 for the new command is optional. Without param
                 you reach an interactive mode.
                 Save config and exit.
    -h|--help    show this help and exit
    -l|--list    list servers
    -t|--tag [TAGNAME(s)]
                 set a tag to filter serverlist.
                 To set multiple tags quote it as a single string
                 and seperate them wih a space. Without param
                 you reach an interactive mode.
                 Save config and exit. 
PARAMETERS:
    The serverlist is a combination of servers that should
    execute the command [hostname -f].
    It can be the number of a server or a 
    A special item is ALL - it executes the command on all servers

    Without a parameter you reach the interactive mode.

EXAMPLES:
    multi_ssh.sh -c               - set a new command. Enter it on the prompt
    multi_ssh.sh -c "sudo reboot" - set a given command
    multi_ssh.sh -t "mon live"    - set filter tags "mon" and "live"
    multi_ssh.sh -l               - list servers that match all tags (AND condition)
    multi_ssh.sh 1 2 5            - run the command on 1st, 2nd and 5th server
    multi_ssh.sh monitor          - run the command on the first server that matches 'monitor'

```

## File structure

```txt
├── color.class.sh          needed file with functions for coloring
├── config
│   ├── commands.txt        list of pre defined commands
│   ├── serverlist.json     Json file with servers and tags
│   └── userconfig.sh       local userspecific config
├── logs
│   └── returncodes.log     log of executed commands
├── multi_ssh.sh         << main script to run
└── README.md               this file
```
